OGRE: Ogre::HardwareBufferManagerBase Class Reference

| OGRE 14.5 Object-Oriented Graphics Rendering Engine

Loading...
Searching...
No Matches
Ogre::HardwareBufferManagerBase Class Referenceabstract
Core » RenderSystem

Base definition of a hardware buffer manager. More...

`#include <OgreHardwareBufferManager.h>`

Inheritance diagram for Ogre::HardwareBufferManagerBase:
[legend]

## Public Member Functions
| HardwareBufferManagerBase ()
virtual | ~HardwareBufferManagerBase ()
void | _forceReleaseBufferCopies (const HardwareVertexBufferSharedPtr &sourceBuffer)
| Internal method that forces the release of copies of a given buffer.
void | _freeUnusedBufferCopies (void)
| Free all unused vertex buffer copies.
void | _notifyVertexBufferDestroyed (HardwareVertexBuffer *buf)
| Notification that a hardware vertex buffer has been destroyed.
void | _releaseBufferCopies (bool forceFreeUnused=false)
| Internal method for releasing all temporary buffers; is called by OGRE.
HardwareVertexBufferSharedPtr | allocateVertexBufferCopy (const HardwareVertexBufferSharedPtr &sourceBuffer, HardwareBufferLicensee *licensee, bool copyData=false)
| Allocates a copy of a given vertex buffer.
virtual HardwareIndexBufferSharedPtr | createIndexBuffer (HardwareIndexBuffer::IndexType itype, size_t numIndexes, HardwareBuffer::Usage usage, bool useShadowBuffer=false)=0
| Create a hardware index buffer.
virtual RenderToVertexBufferSharedPtr | createRenderToVertexBuffer ()
| Create a render to vertex buffer.
virtual HardwareBufferPtr | createUniformBuffer (size_t sizeBytes, HardwareBufferUsage usage=HBU_CPU_TO_GPU, bool useShadowBuffer=false)
| Create uniform buffer.
virtual HardwareVertexBufferSharedPtr | createVertexBuffer (size_t vertexSize, size_t numVerts, HardwareBuffer::Usage usage, bool useShadowBuffer=false)=0
| Create a hardware vertex buffer.
VertexBufferBinding * | createVertexBufferBinding (void)
| Creates a new VertexBufferBinding.
VertexDeclaration * | createVertexDeclaration (void)
| Creates a new vertex declaration.
void | destroyVertexBufferBinding (VertexBufferBinding *binding)
| Destroys a VertexBufferBinding.
void | destroyVertexDeclaration (VertexDeclaration *decl)
| Destroys a vertex declaration.
void | releaseVertexBufferCopy (const HardwareVertexBufferSharedPtr &bufferCopy)
| Manually release a vertex buffer copy for others to subsequently use.
void | touchVertexBufferCopy (const HardwareVertexBufferSharedPtr &bufferCopy)
| Tell engine that the vertex buffer copy intent to reuse.

## Detailed Description

Base definition of a hardware buffer manager.

This class is deliberately not a Singleton, so that multiple types can exist at once (notably DefaultHardwareBufferManagerBase). The Singleton is add via the inheritance in HardwareBufferManager below.

## Constructor & Destructor Documentation

## ◆ HardwareBufferManagerBase()

Ogre::HardwareBufferManagerBase::HardwareBufferManagerBase | ( |  | ) |

## ◆ ~HardwareBufferManagerBase()

virtual Ogre::HardwareBufferManagerBase::~HardwareBufferManagerBase | ( |  | ) |
| virtual

## Member Function Documentation

## ◆ createVertexBuffer()

virtual HardwareVertexBufferSharedPtr Ogre::HardwareBufferManagerBase::createVertexBuffer | ( | size_t | vertexSize,
|  | size_t | numVerts,
|  | HardwareBuffer::Usage | usage,
|  | bool | useShadowBuffer = false )
| pure virtual

Create a hardware vertex buffer.

This method creates a new vertex buffer; this will act as a source of geometry data for rendering objects. Note that because the meaning of the contents of the vertex buffer depends on the usage, this method does not specify a vertex format; the user of this buffer can actually insert whatever data they wish, in any format. However, in order to use this with a RenderOperation, the data in this vertex buffer will have to be associated with a semantic element of the rendering pipeline, e.g. a position, or texture coordinates. This is done using the VertexDeclaration class, which itself contains VertexElement structures referring to the source data. Note that because vertex buffers can be shared, they are reference counted so you do not need to worry about destroying them this will be done automatically.

Parameters

  vertexSize | The size in bytes of each vertex in this buffer; you must calculate this based on the kind of data you expect to populate this buffer with.
  numVerts | The number of vertices in this buffer.
  usage | One or more members of the HardwareBufferUsage enumeration; you are strongly advised to use HBU_GPU_ONLY wherever possible, if you need to update regularly, consider HBU_CPU_TO_GPU or useShadowBuffer=true.
  useShadowBuffer | If set to `true`, this buffer will be 'shadowed' by one stored in system memory rather than GPU memory. See Shadow Buffers.

Implemented in Ogre::DefaultHardwareBufferManager, and Ogre::DefaultHardwareBufferManagerBase.

## ◆ createIndexBuffer()

virtual HardwareIndexBufferSharedPtr Ogre::HardwareBufferManagerBase::createIndexBuffer | ( | HardwareIndexBuffer::IndexType | itype,
|  | size_t | numIndexes,
|  | HardwareBuffer::Usage | usage,
|  | bool | useShadowBuffer = false )
| pure virtual

Create a hardware index buffer.

Remarks
  Note that because buffers can be shared, they are reference counted so you do not need to worry about destroying them this will be done automatically.

Parameters

  itype | The type in index, either 16- or 32-bit, depending on how many vertices you need to be able to address
  numIndexes | The number of indexes in the buffer
  usage | One or more members of the HardwareBufferUsage enumeration.
  useShadowBuffer | If set to `true`, this buffer will be 'shadowed' by one stored in system memory rather than GPU memory. See Shadow Buffers.

Implemented in Ogre::DefaultHardwareBufferManager, and Ogre::DefaultHardwareBufferManagerBase.

## ◆ createRenderToVertexBuffer()

virtual RenderToVertexBufferSharedPtr Ogre::HardwareBufferManagerBase::createRenderToVertexBuffer | ( |  | ) |
| virtual

Create a render to vertex buffer.

Remarks
  The parameters (such as vertex size etc) are determined later and are allocated when needed.

Reimplemented in Ogre::DefaultHardwareBufferManager.

## ◆ createUniformBuffer()

virtual HardwareBufferPtr Ogre::HardwareBufferManagerBase::createUniformBuffer | ( | size_t | sizeBytes,
|  | HardwareBufferUsage | usage = HBU_CPU_TO_GPU,
|  | bool | useShadowBuffer = false )
| virtual

Create uniform buffer.

This type of buffer allows the upload of shader constants once, and sharing between shader stages or even shaders from another materials. The update shall be triggered by GpuProgramParameters, if is dirty

Reimplemented in Ogre::DefaultHardwareBufferManager, and Ogre::DefaultHardwareBufferManagerBase.

References Ogre::HBU_CPU_TO_GPU.

## ◆ createVertexDeclaration()

VertexDeclaration * Ogre::HardwareBufferManagerBase::createVertexDeclaration | ( | void |  | ) |

Creates a new vertex declaration.

## ◆ destroyVertexDeclaration()

void Ogre::HardwareBufferManagerBase::destroyVertexDeclaration | ( | VertexDeclaration * | decl | ) |

Destroys a vertex declaration.

## ◆ createVertexBufferBinding()

VertexBufferBinding * Ogre::HardwareBufferManagerBase::createVertexBufferBinding | ( | void |  | ) |

Creates a new VertexBufferBinding.

## ◆ destroyVertexBufferBinding()

void Ogre::HardwareBufferManagerBase::destroyVertexBufferBinding | ( | VertexBufferBinding * | binding | ) |

Destroys a VertexBufferBinding.

## ◆ allocateVertexBufferCopy()

HardwareVertexBufferSharedPtr Ogre::HardwareBufferManagerBase::allocateVertexBufferCopy | ( | const HardwareVertexBufferSharedPtr & | sourceBuffer,
|  | HardwareBufferLicensee * | licensee,
|  | bool | copyData = false )

Allocates a copy of a given vertex buffer.

This method allocates a temporary copy of an existing vertex buffer. This buffer is subsequently stored and can be made available for other purposes later without incurring the cost of construction / destruction.

Parameters

  sourceBuffer | The source buffer to use as a copy.
  licensee | Pointer back to the class requesting the copy, which must implement HardwareBufferLicense in order to be notified when the license expires.
  copyData | If `true`, the current data is copied as well as the structure of the buffer/

## ◆ releaseVertexBufferCopy()

void Ogre::HardwareBufferManagerBase::releaseVertexBufferCopy | ( | const HardwareVertexBufferSharedPtr & | bufferCopy | ) |

Manually release a vertex buffer copy for others to subsequently use.

Parameters

  bufferCopy | The buffer copy. The caller is expected to delete or at least no longer use this reference, since another user may well begin to modify the contents of the buffer.

## ◆ touchVertexBufferCopy()

void Ogre::HardwareBufferManagerBase::touchVertexBufferCopy | ( | const HardwareVertexBufferSharedPtr & | bufferCopy | ) |

Tell engine that the vertex buffer copy intent to reuse.

Ogre internal keep an expired delay counter. When the counter count down to zero, it'll release for other purposes later. But you can use this function to reset the counter to the internal configured value, keep the buffer not get released for some frames.

Parameters

  bufferCopy | The buffer copy. The caller is expected to keep this buffer copy for use.

## ◆ _freeUnusedBufferCopies()

void Ogre::HardwareBufferManagerBase::_freeUnusedBufferCopies | ( | void |  | ) |

Free all unused vertex buffer copies.

This method free all temporary vertex buffers that not in used. In normally, temporary vertex buffers are subsequently stored and can be made available for other purposes later without incurring the cost of construction / destruction. But in some cases you want to free them to save hardware memory (e.g. application was runs in a long time, you might free temporary buffers periodically to avoid memory overload).

## ◆ _releaseBufferCopies()

void Ogre::HardwareBufferManagerBase::_releaseBufferCopies | ( | bool | forceFreeUnused = false | ) |

Internal method for releasing all temporary buffers; is called by OGRE.

Parameters

  forceFreeUnused | If `true`, free all unused temporary buffers. If `false`, auto detect and free all unused temporary buffers based on temporary buffers utilization.

## ◆ _forceReleaseBufferCopies()

void Ogre::HardwareBufferManagerBase::_forceReleaseBufferCopies | ( | const HardwareVertexBufferSharedPtr & | sourceBuffer | ) |

Internal method that forces the release of copies of a given buffer.

This usually means that the buffer which the copies are based on has been changed in some fundamental way, and the owner of the original wishes to make that known so that new copies will reflect the changes.

Parameters

  sourceBuffer | The source buffer as a shared pointer. Any buffer copies created from the source buffer are deleted.

## ◆ _notifyVertexBufferDestroyed()

void Ogre::HardwareBufferManagerBase::_notifyVertexBufferDestroyed | ( | HardwareVertexBuffer * | buf | ) |

Notification that a hardware vertex buffer has been destroyed.

The documentation for this class was generated from the following file:

- OgreHardwareBufferManager.h